# -*- coding: utf-8 -*-
import os,sys
import re
from Tkinter import *
import time

barvy = {"A":"azurová","R":"červená","G":"zelená","B":"modrá","Y":"žlutá"}
hexa = {"A":"#00FFFF","R":"#FF0000","G":"#00FF00","B":"#0000FF","Y":"#FFFF00"}

class App:
    def __init__(self):
        soubory = os.listdir(os.curdir)
        import tkFileDialog
        cesta = tkFileDialog.askopenfilename()
        self.zpracuj(cesta)
        """d = []
        for i in soubory:
            a = i.split(".")
            if a[1] == "99" or a[1] == "29":
                d.append(i)


       
        for i in d:
            print "soubor "+ i
            k = self.zpracuj(i)
            """
    def zpracuj(self,f):
        f = open(f,"r")
        init = f.readline()
        init = " ".join(init.split())
        a = init.rstrip(" ").lstrip(" ").split(" ")
        self.vez_x = int(a[0])
        self.vez_y = int(a[1])
        
        vez_t = a[2]
       
        data = []
        raw_data = []
        kostky = {}
        self.patro = 1
        self.mod = "patra"

        

        # kostky [patro x y barva rozměry]
        for line in f:
            line = " ".join(line.split())
            
            try:
                if line.find("X") == -1:
                    a = line.split(" ")[4].split("x")[0]
                    b = line.split(" ")[4].split("x")[1]
                else:
                    
                    a = line.split(" ")[4].split("X")[0]
                    b = line.split(" ")[4].split("X")[1]
                    
                if a < b:
                    c = b+"x"+a
                else:
                    c = a+"x"+b           
                data.append([line.split(" ")[0],line.split(" ")[1],line.split(" ")[2],line.split(" ")[3],c])
                raw_data.append([line.split(" ")[0],line.split(" ")[1],line.split(" ")[2],line.split(" ")[3],line.split(" ")[4].replace("X","x")])
            except:
                pass
               

        self.data = raw_data
        self.raw_data = raw_data
        
        self.vez_z = raw_data[-5][0]
        
        

            
        

        
        for i in data:
            typ = str(i[3]) + "|" + str(i[4])
            
            if typ in kostky:
                kostky[typ] += 1
            else:
                kostky[typ] = 1


        #vypis rekapitulace
        vypis = []
        for i in kostky:
            vypis.append(barvy[i.split("|")[0]] + " " + i.split("|")[1] + " " + str(kostky[i] ))
        vypis.sort()
        self.vypis = vypis

        
        
           

       
        

        self.master = Tk()
        

        if self.mod == "patra":
            self.patra()
        mainloop()
    def strany(self):
        self.master.destroy()
        self.master = Tk()
        nabidka = Menu(self.master)
        self.master.config(menu=nabidka)

        menuSoubor = Menu(nabidka)
        nabidka.add_cascade(label="Zobrazeni", menu=menuSoubor)
        menuSoubor.add_command(label=u"Strany", command=self.set_strany)
        menuSoubor.add_command(label=u"Patra", command=self.set_patra)
        menuSoubor.add_command(label=u"rekapitulace", command=self.rekapitulace)
        self.w = Canvas(self.master, width=50*self.vez_x+100, height=50*int(self.vez_z)+100)
        
        self.w.pack()
        self.w.create_rectangle(50,50,50*self.vez_x,50*self.vez_y,fill="white")

        
      
        b = Button(self.master,text="Levá",command=self.zvedni).pack(side=TOP)
        b = Button(self.master,text="Pravá",command=self.sniz).pack(side=TOP)
        b = Button(self.master,text="Přední",command=self.sniz).pack(side=TOP)
        b = Button(self.master,text="Zadní",command=self.sniz).pack(side=TOP)

    def rekapitulace(self):
        for i in self.vypis:
            print i
            
    def patra(self):
        self.master.destroy()
        self.master = Tk()
        nabidka = Menu(self.master)
        self.master.config(menu=nabidka)

        menuSoubor = Menu(nabidka)
        nabidka.add_cascade(label="Zobrazeni", menu=menuSoubor)
        menuSoubor.add_command(label=u"Strany", command=self.set_strany)
        menuSoubor.add_command(label=u"Patra", command=self.set_patra)
        menuSoubor.add_command(label=u"rekapitulace", command=self.rekapitulace)
    
        b = Button(self.master,text="Patro nahoru",command=self.zvedni).pack()
        b = Button(self.master,text="Patro dolu",command=self.sniz).pack()
        self.t_patro = StringVar()
        Label(self.master, textvariable=self.t_patro).pack()
        self.w = Canvas(self.master, width=50*self.vez_x+100, height=50*self.vez_y+100)
        self.t_patro.set(str(self.patro))
        self.w.pack()
        self.w.create_rectangle(50,50,50*self.vez_x,50*self.vez_y,fill="white")
        self.zobraz(self.w,self.patro,self.raw_data)


        


    def set_patra(self):
        self.mod = "patra"
        self.patra()

    def set_strany(self):
        self.mod = "strany"
        self.strany()

    def zobraz(self,w,patro,data):
        self.w.create_rectangle(50,50,50*self.vez_x,50*self.vez_y,fill="white")
        for i in data:
            
            if int(i[0]) == self.patro:
                
                x1 = int(i[1])*50 
                y1 = int(i[2])*50
                x2 = x1 + int(i[4].split("x")[0])*50
                y2 = y1 + int(i[4].split("x")[1])*50
                
                w.create_rectangle(x1,y1,x2,y2,fill=hexa[i[3]])
                
    def sniz(self):
        if not self.patro == 1:
            self.patro -= 1
            self.t_patro.set(str(self.patro))
            self.zobraz(self.w,self.patro,self.data)

    def zvedni(self):
        if not self.patro == int(self.vez_z):
            self.patro += 1
            self.t_patro.set(str(self.patro))
            self.zobraz(self.w,self.patro,self.data)

        
a = App()

    

 


    
